#ifndef __BOARD_H__
#define __BOARD_H__

#include <FK/FK.h>
#include "Stone.h"


// 2zł̍Wld\
struct CellPosition {
	int	x, y;
};

// 2zŎ΂̗vfԍƐFɊg
struct CellData {
	int			index;
	StoneColor	color;
};

// IZ̔Ֆʂ\NX
class Board {
public:
	// RXgN^ƃfXgN^
	Board(void);
	virtual ~Board(void);
	
	// [6/5]Ֆʃf[^
	void	initBoard(void);
	// Ֆʂ`鏈
	void	setupBoard(void);
	// \E\֐ĊO琧ł悤
	void	entry(fk_Scene *scene);
	void	remove(fk_Scene *scene);
	
	// NbNꂽʒu1ɓnA␳ʂ2ɕԂB
	// ܂ԒlƂāAɒuȂ-1A͈͊OȂ-2A
	// ɐ΂uĂꍇ̗͂vfԍԂB
	int		checkCell(const fk_Vector &pos, fk_Vector *adjustPos);
	// u΂ID(z̓Y)
	void	setStoneID(const fk_Vector &pos, int id, StoneColor color = ST_DEFAULT);
	// ̐΂ӂɂ邩𒲂ׂ֐
	bool	checkAround(StoneColor color, const fk_Vector &pos);

	// -35`35̍Wl0`7ɕϊ
	CellPosition	calcID(const fk_Vector &pos);

protected:
	// Ֆʕ\po
	fk_Block		block;
	fk_Model		blockModel;
	fk_Line			grid;
	fk_Model		gridModel;
	// Ֆʏ̃f[^2zŎ
	CellData		cellInfo[8][8];
};


#endif //__BOARD_H__
