#ifndef __STONE_H__
#define __STONE_H__

#include <FK/FK.h>

enum StoneColor {
	ST_DEFAULT = -1,
	ST_BLACK,
	ST_WHITE
};

// IZ̐΂\NX
class Stone {
public:
	// RXgN^ƃfXgN^
	Stone(StoneColor color);
	virtual ~Stone(void);
	// ՖʂƓ\E\O
	void entry(fk_Scene *scene);
	void remove(fk_Scene *scene);
	
	// ʒuw
	void setPosition(const fk_Vector &pos);
	// ЂԂ(w肵Ȃꍇ͔]Aw肳Ă炻ɏ])
	void reverse(StoneColor color = ST_DEFAULT);

	// ʒu擾
	fk_Vector	getPosition(void);
	// F擾
	StoneColor	getColor(void);

	// [6/5]ԍXV
	void		update(void);

	static StoneColor opposite(StoneColor color);

protected:
	StoneColor	color;
	fk_Prism	stoneShape;
	fk_Model	stoneModel, blackModel, whiteModel;
	double		spinRad;
};

#endif //__STONE_H__
